           (*-------------------------------------------*
            |  The Dining Mathematicians in Csp-Prover  |
            |               August 2004                 |
            |             December 2004 (modified)      |
            |        Yoshinao Isobe (AIST JAPAN)        |
            *-------------------------------------------*)

theory DM12_Seq_Sys = DM11_Seq_Sys:

(*****************************************************************

         1. proves lemma for Seq =F Sys
         2.
         3. 
         4. 

 *****************************************************************)

(*** Seq_TH0_EAT1 ***)

lemma Seq_TH0_EAT1:
  "LET SysDef IN (Rewrite (SeqDef (Seq_TH0_EAT1 n)) By Seq_to_Sys) =F
   LET SysDef IN Seq_to_Sys (Seq_TH0_EAT1 n)"
apply (case_tac "ODD n")
apply (tactic {* csp_simp_add_tac "unfold_SYS_rules" 1 *})
done

lemmas SEQ_rules = SEQ_rules Seq_TH0_EAT1

(*** Seq_EAT0_TH1 ***)

lemma Seq_EAT0_TH1:
  "LET SysDef IN (Rewrite (SeqDef (Seq_EAT0_TH1 n)) By Seq_to_Sys) =F
   LET SysDef IN Seq_to_Sys (Seq_EAT0_TH1 n)"
apply (case_tac "ODD n")
apply (tactic {* csp_simp_add_tac "unfold_SYS_rules" 1 *})
done

lemmas SEQ_rules = SEQ_rules Seq_EAT0_TH1

(*** Seq_TH0_Back1 ***)

lemma Seq_TH0_Back1:
  "LET SysDef IN (Rewrite (SeqDef (Seq_TH0_Back1 n)) By Seq_to_Sys) =F
   LET SysDef IN Seq_to_Sys (Seq_TH0_Back1 n)"
apply (case_tac "ODD n")
apply (tactic {* csp_simp_add_tac "unfold_SYS_rules" 1 *})
done

lemmas SEQ_rules = SEQ_rules Seq_TH0_Back1

(*** Seq_Back0_TH1 ***)

lemma Seq_Back0_TH1:
  "LET SysDef IN (Rewrite (SeqDef (Seq_Back0_TH1 n)) By Seq_to_Sys) =F
   LET SysDef IN Seq_to_Sys (Seq_Back0_TH1 n)"
apply (case_tac "ODD n")
apply (tactic {* csp_simp_add_tac "unfold_SYS_rules" 1 *})
done

lemmas SEQ_rules = SEQ_rules Seq_Back0_TH1

end
